class DB {
    env_;//云环境id
    name_;//集合或库的名称
    cloud_ = wx.cloud;
    database_;//代表,database
    table_;//代表,table
    t_data_;//代表捕捉到的数据
    command_;//代表其它，非等于情况的条件
    find_=0;//代表是否以id获取了数据
    constructor(name,env)
    {
        this.name_ = name||'Abc';
        this.env_ = env||'a123';
        this.cloud_.init({
            env: this.env_
        });
        this.database_ = this.cloud_.database();
        this.table_ = this.database_.collection(this.name_);
        this.command_ = this.database_.command;
    }
    error_(err)
    {
        console.error(err);
    }
    //添加缓存
    setStorage(key,val)
    {
        return new Promise((resolve,reject)=>{
            wx.setStorage({
                key:this.name_+key,
                data:val,
                success (res) {
                    resolve(res);
                },
                fail(res){
                    reject(res);
                }
            });
        });
    }
    //获取缓存
    getStorage(key)
    {
        return new Promise((resolve,reject)=>{
            wx.getStorage({
                key: this.name_+key,
                success (res) {
                    resolve(res);
                },
                fail(res){
                    reject(res);
                }
            });
        });
    }
    /*删除指定的缓存*/
    deleteStorage(key)
    {
        return new Promise((resolve,reject)=>{
            wx.removeStorage({
                key: this.name_+key,
                success (res) {
                    resolve(res);
                },
                fail(res)
                {
                    reject(res);
                }
            });
        });
    }
    /*清理所有缓存*/
    deleteStorageAll()
    {
        return new Promise((resolve,reject)=>{
            wx.clearStorage({
                success (res) {
                    resolve(res);
                },
                fail(res)
                {
                    reject(res);
                }
            });
        });
    }
    getOpenid()
    {
        //通过云函数获取。需要开通云函数，并上传默认生成的login云函数
        return wx.cloud.callFunction({
            name: 'login',
        });
        /*通过链接获取，现在行不通了
        let this_ = this;
        return new Promise((resolve,reject)=>{
            wx.login({
                success (res) {
                    if (res.code) {
                        //发起网络请求
                        wx.request({
                            url: 'https://api.weixin.qq.com/sns/jscode2session',//正式环境无法请求，无法加白名单
                            data: {
                                appid: appid,
                                secret: secret,
                                js_code: res.code,
                                grant_type: 'authorization_code'
                            },
                            header: {
                                'content-type': 'application/json' // 默认值
                            },
                            success (res) {
                                resolve(res);
                            },
                            fail(err) {
                                reject(err);
                            }
                        });
                    }
                }
            });
        });*/
    }
    /**
     * @param key string 字段名称
     * @param val string|object 可以是字符串，也可以是{publishYear: 2018,language: 'zh-CN'}
     * @param where string 条件
     * */
    where_(key,where,val)
    {
        switch(where){
            case '=':
                this.t_data_ = this.table_.where({
                    [key]: this.command_.eq(val)
                });
                break;
            case '!=':
                this.t_data_ = this.table_.where({
                    [key]: this.command_.neq(val)
                });
                break;
            case '<':
                val = Number(val);
                this.t_data_ = this.table_.where({
                    [key]: this.command_.lt(val)
                });
                break;
            case '<=':
                val = Number(val);
                this.t_data_ = this.table_.where({
                    [key]: this.command_.lte(val)
                });
                break;
            case '>':
                val = Number(val);
                this.t_data_ = this.table_.where({
                    [key]: this.command_.gt(val)
                });
                break;
            case '>=':
                val = Number(val);
                this.t_data_ = this.table_.where({
                    [key]: this.command_.gte(val)
                });
                break;
            case 'in':
                this.t_data_ = this.table_.where({
                    [key]: this.command_.in(val) //.in([0, 100])//0 或 100
                });
                break;
            case 'nin':
                this.t_data_ = this.table_.where({
                    [key]: this.command_.nin(val) //.in([0, 100])//不是 0 或 100
                });
                break;
            default:
                this.t_data_ = this.table_.where({
                    [key]: this.command_.eq(val)
                });
        }
    }
    /*GameDB.where('money','&',['<','15'],['<','16']).get().then(res => {console.log(res);});*/
    where2_(key,where,val,val2)
    {
        switch(where){
            case '|':
                if(val[0]=='='&&val2[0]=='='){
                    this.t_data_ = this.table_.where({
                        [key]: this.command_.or(this.command_.eq(val[1]),this.command_.eq(val2[1])) //_.or([_.gt(80), _.lt(20)])//大于 80 或小于 20
                    });
                }else{
                    val[1] = Number(val[1]);
                    val2[1] = Number(val2[1]);
                    if(val[0]=='>'&&val2[0]=='<'){
                        this.t_data_ = this.table_.where({
                            [key]: this.command_.or(this.command_.gt(val[1]),this.command_.lt(val2[1])) //_.or([_.gt(80), _.lt(20)])//大于 80 或小于 20
                        });
                    }else if(val[0]=='<'&&val2[0]=='>'){
                        this.t_data_ = this.table_.where({
                            [key]: this.command_.or(this.command_.lt(val[1]),this.command_.gt(val2[1]))
                        });
                    }else if(val[0]=='<'&&val2[0]=='='){
                        this.t_data_ = this.table_.where({
                            [key]: this.command_.or(this.command_.lt(val[1]),this.command_.eq(val2[1]))
                        });
                    }else if(val[0]=='>'&&val2[0]=='='){
                        this.t_data_ = this.table_.where({
                            [key]: this.command_.or(this.command_.gt(val[1]),this.command_.eq(val2[1]))
                        });
                    }else if(val[0]=='<'&&val2[0]=='<'){
                        this.t_data_ = this.table_.where({
                            [key]: this.command_.or(this.command_.lt(val[1]),this.command_.lt(val2[1]))
                        });
                    }else if(val[0]=='>'&&val2[0]=='>'){
                        this.t_data_ = this.table_.where({
                            [key]: this.command_.or(this.command_.gt(val[1]),this.command_.gt(val2[1]))
                        });
                    }
                }
                break;
            case '&':
                val[1] = Number(val[1]);
                val2[1] = Number(val2[1]);
                if(val[0]=='>'&&val2[0]=='<'){
                    this.t_data_ = this.table_.where({
                        [key]: this.command_.and(this.command_.gt(val[1]),this.command_.lt(val2[1])) //_.or([_.gt(80), _.lt(20)])//大于 80 或小于 20
                    });
                }else if(val[0]=='<'&&val2[0]=='>'){
                    this.t_data_ = this.table_.where({
                        [key]: this.command_.and(this.command_.lt(val[1]),this.command_.gt(val2[1]))
                    });
                }else if(val[0]=='<'&&val2[0]=='='){
                    this.t_data_ = this.table_.where({
                        [key]: this.command_.and(this.command_.lt(val[1]),this.command_.eq(val2[1]))
                    });
                }else if(val[0]=='>'&&val2[0]=='='){
                    this.t_data_ = this.table_.where({
                        [key]: this.command_.and(this.command_.gt(val[1]),this.command_.eq(val2[1]))
                    });
                }else if(val[0]=='<'&&val2[0]=='<'){
                    this.t_data_ = this.table_.where({
                        [key]: this.command_.and(this.command_.lt(val[1]),this.command_.lt(val2[1]))
                    });
                }else if(val[0]=='>'&&val2[0]=='>'){
                    this.t_data_ = this.table_.where({
                        [key]: this.command_.and(this.command_.gt(val[1]),this.command_.gt(val2[1]))
                    });
                }
                break;
        }
    }
    //以id捕捉，外部调用
    find(id)
    {
        this.find_ = 1;
        this.t_data_ = this.table_.doc(id);
        return this;
    }
    //以id捕捉，内部调用
    doc(id)
    {
        this.find_ = 0;
        this.t_data_ = this.table_.doc(id);
        return this;
    }
    //捕捉全部
    all()
    {
        this.find_ = 0;
        this.t_data_ = this.table_.where({});
        return this;
    }
    /**
     * 以条件捕捉
     * @param key string
     * @param where string 条件，大于小二等于符号
     * @param val string
     * @param val2 string 当val2有值的时候，就是and与or的判断,例:key='name',where='|',val=['>',10],val2=['<',20]
     * aaa=bbb && ccc=ddd
     */
    where(key,where,val,val2)
    {
        this.find_ = 0;
        if(val){
            if(val2){
                this.where2_(key,where,val,val2);
            }else{
                this.where_(key,where,val);
            }
        }else{
            let obj = {[key]:where};
            this.t_data_ = this.table_.where(obj);
        }
        return this;
    }
    /*调用方式必须先调用where在调用，传值类似，暂时只能用于获取数据*/
    orWhere(key,where,val,val2)
    {
        this.find_ = 0;
        let where_=(resolve)=>
        {
            this.t_data_.get().then(res=>{
                if(val){
                    if(val2){
                        this.where2_(key,where,val,val2);
                    }else{
                        this.where_(key,where,val);
                    }
                }else{
                    let obj = {[key]:where};
                    this.t_data_ = this.table_.where(obj);
                }
                this.t_data_.get().then(res2=>{
                    resolve({data:res.data.concat(res2.data)});
                });
            });
        };
        return {
            get:function(){
                return new Promise(where_);
            }
        };
    }
    andOpenid()
    {
        this.getOpenid().then(res=>{
            let obj = {'_openid':res.result['openid']};
            this.t_data_ = this.table_.where(obj);
        });
        return this;
    }
    /**
     * 先捕捉数据在调用
     * @param key string|Object 对哪个字段自增，或{'money':1,'undefined':1}
     * @param number integer 一次增加多少个
     * */
    increment(key,number)
    {
        number = number|1;
        let data = {};
        if(key.constructor === Object){
            for(let i in key){
                data[i] = this.command_.inc(key[i]);
            }
        }else{
            data = {
                [key]: this.command_.inc(number)
            }
        }
        if(this.find_){
            return this.t_data_.update({
                data: data
            }).catch((err)=>{
                this.error_(err);
            });
        }else{
            return new Promise((resolve)=>{
                this.t_data_.get().then(res => {
                    let new_obj = {'stats':{'updated':0},'errMsg':-1,'data':{}};
                    if(res.data){
                        if(res.data['_id']){
                            new_obj['errMsg']='collection.get:ok';
                            new_obj['stats']['updated']=1;
                            new_obj['data']['_id']=res.data['_id'];
                            new_obj['data'][key]=res.data[key];
                            this.doc(res.data['_id']);
                            this.t_data_.update({
                                data: data
                            }).catch((err)=>{
                                this.error_(err);
                            });
                        }else if(res.data.constructor === Array){
                            new_obj['errMsg']='collection.get:ok';
                            for(let i in res.data){
                                new_obj['stats']['updated']+=1;
                                new_obj['data'][i] = {};
                                new_obj['data'][i]['_id']=res.data[i]['_id'];
                                new_obj['data'][i][key]=res.data[i][key];
                                this.doc(res.data[i]['_id']);
                                this.t_data_.update({
                                    data: data
                                }).catch((err)=>{
                                    this.error_(err);
                                });
                            }
                        }
                    }
                    resolve(new_obj);
                });
            });
        }
    }
    /**
     * 只返回需要的字段
     * @param data string|array 要显示的字段如'_openid'或['_id','_openid']
     */
    select(data)
    {
        //data = '_openid';
        //data = ['description','_openid'];
        let obj = {};
        if(data.constructor === Array){
            for(let i=0;i<data.length;i++){
                obj[data[i]] = true;
            }
        }else if(data.constructor === String){
            obj[data] = true;
        }
        if(this.t_data_){
            return new Promise((resolve)=>{
                this.t_data_.get().then(res => {
                    let new_obj = {'data':[],'errMsg':-1};
                    if(res.data.constructor === Array){
                        new_obj['errMsg']='collection.get:ok';
                        for(let i in res.data){
                            new_obj['data'][i]={};
                            new_obj['data'][i]['_id'] = res.data[i]['_id'];
                            for(let ii in obj){
                                if(res.data[i][ii]){
                                    new_obj['data'][i][ii] = res.data[i][ii];
                                }
                            }
                        }
                    }
                    resolve(new_obj);
                });
            });
        }else{
            return this.table_.field(obj).get();
        }
    }
    /**
     * @param skip int 跳过结果集中的前 10 条，从第 11 条开始返回
     */
    skip(skip)
    {
        skip = skip||0;
        this.t_data_ = this.t_data_.skip(skip);
        return this;
    }
    /**
     * 在配合skip()使用的时候先调用skip,先跳过不需要的的在返回10条
     * @param limit int 限制返回数量为 10 条
     * GameDB.orderBy([{'_id':'desc'},{'_openid':'asc'},{'money':'asc'}]).take(2).get().then(res => {console.log(res);});
     */
    take(limit)
    {
        limit = limit||10;
        this.t_data_ = this.t_data_.limit(limit);
        return this;
    }
    /**
     * 排序
     * @param data string|object|data 如{'_id':'desc'}_id字段以降序排，如[{'_id':'desc'}{'_openid':'asc'}]先以_id降序排在以_openid升序排
     * @param val string 如desc
     * */
    orderBy(data,val)
    {
        //data = [{'_id':'desc'},{'_openid':'asc'}];
        //data = {'_id':'desc'};
        if(this.t_data_){
            if(val){
                this.t_data_ = this.t_data_.orderBy(data, val);
            }else if(data.constructor === Array){
                switch(data.length){
                    case 1:
                        this.t_data_ = this.t_data_.orderBy(Object.keys(data[0])[0], data[0][Object.keys(data[0])[0]]);
                        break;
                    case 2:
                        this.t_data_ = this.t_data_.orderBy(Object.keys(data[0])[0], data[0][Object.keys(data[0])[0]]).orderBy(Object.keys(data[1])[0], data[1][Object.keys(data[1])[0]]);
                        break;
                    case 3:
                        this.t_data_ = this.t_data_.orderBy(Object.keys(data[0])[0], data[0][Object.keys(data[0])[0]]).orderBy(Object.keys(data[1])[0], data[1][Object.keys(data[1])[0]]).orderBy(Object.keys(data[2])[0], data[2][Object.keys(data[2])[0]]);
                        break;
                }
            }else if(data.constructor === Object){
                this.t_data_ = this.t_data_.orderBy(Object.keys(data)[0], data[Object.keys(data)]);
            }
        }else{
            if(val){
                this.t_data_ = this.table_.orderBy(data, val);
            }else if(data.constructor === Array){
                switch(data.length){
                    case 1:
                        this.t_data_ = this.table_.orderBy(Object.keys(data[0])[0], data[0][Object.keys(data[0])[0]]);
                        break;
                    case 2:
                        this.t_data_ = this.table_.orderBy(Object.keys(data[0])[0], data[0][Object.keys(data[0])[0]]).orderBy(Object.keys(data[1])[0], data[1][Object.keys(data[1])[0]]);
                        break;
                    case 3:
                        this.t_data_ = this.table_.orderBy(Object.keys(data[0])[0], data[0][Object.keys(data[0])[0]]).orderBy(Object.keys(data[1])[0], data[1][Object.keys(data[1])[0]]).orderBy(Object.keys(data[2])[0], data[2][Object.keys(data[2])[0]]);
                        break;
                }
            }else if(data.constructor === Object){
                this.t_data_ = this.table_.orderBy(Object.keys(data)[0], data[Object.keys(data)]);
            }
        }
        return this;
        /*不支持把字符串转代码
        data = [{'_id':'desc'}{'_openid':'asc'}];
        let orderBy = '';
        if(data){
            if(data.constructor === Array){
                for(let i in data){
                    for(let ii in data[i]){
                        orderBy+='.orderBy(\''+ii+'\',\''+data[i][ii]+'\')';
                    }
                }
            }else if(data.constructor === Object){
                for(let i in data){
                    orderBy+='.orderBy(\''+i+'\',\''+data[i]+'\')';
                }
            }
        }
        */
    }
    /*data可以是对象或字符串...*/
    create(data)
    {
        return this.table_.add({
            // data 字段表示需新增的 JSON 数据
            data
        }).catch((err)=>{
            this.error_(err);
        });
    }
    /*先捕捉数据然后调用它，返回get()在后面拼接成功后事件then(res => {console.log(res);})*/
    get(field)
    {
        if(field){
            return this.select(field);
        }else{
            return this.t_data_.get().catch((err)=>{
                this.error_(err);
            });
        }
    }
    /*
    局部更新数据
    先捕捉数据然后调用它，GameDB.id('aaa').update({aaa: "abccc"})将字段为aaa的值改为abccc，与set区别:其它的值不会改变*/
    update(data)
    {
        if(data['_id']){
            delete data['_id'];
        }
        if(data['_openid']){
            delete data['_openid'];
        }
        if(this.find_){
            return this.t_data_.update({
                data:data
            }).catch((err)=>{
                this.error_(err);
            });
        }else{
            return new Promise((resolve)=>{
                let new_obj = {'stats':{},'errMsg':-1};
                if(this.t_data_){
                    this.t_data_.get().then(res => {
                        if(res.data){
                            if(res.data['_id']){
                                new_obj['errMsg']='document.update:ok';
                                new_obj['stats']['update']=1;
                                this.doc(res.data['_id']);
                                this.t_data_.update({
                                    data:data
                                }).catch((err)=>{
                                    this.error_(err);
                                });
                            }else if(res.data.constructor === Array){
                                new_obj['errMsg']='document.update:ok';
                                new_obj['stats']['update']=0;
                                for(let i in res.data){
                                    new_obj['stats']['update']+=1;
                                    this.doc(res.data[i]['_id']);
                                    this.t_data_.update({
                                        data:data
                                    }).catch((err)=>{
                                        this.error_(err);
                                    });
                                }
                            }
                        }
                        resolve(new_obj);
                    }).catch((err)=>{
                        this.error_(err);
                    });
                }else{
                    new_obj['stats']['update']=0;
                    resolve(new_obj);
                }
            });
        }
    }
    /*
    替换更新记录
    先捕捉数据然后调用它，GameDB.id('aaa').set({aaa: "abccc"})，与update区别：data会变成{aaa: "abccc"}*/
    set(data)
    {
        return this.t_data_.set({
            data
        }).catch((err)=>{
            this.error_(err);
        });
    }
    /*先捕捉数据然后调用它，删除捕捉到的数据，field如果有则只删除该字段*/
    delete(field)
    {
        if(this.find_){
            if(field){
                return this.t_data_.update({
                    data:{
                        [field]:this.command_.remove()
                    }
                }).catch((err)=>{
                    this.error_(err);
                });
            }else{
                return this.t_data_.remove().catch((err)=>{
                    this.error_(err);
                });
            }
        }else{
            return new Promise((resolve)=>{
                this.t_data_.get().then(res => {
                    let new_obj = {'stats':{},'errMsg':-1};
                    if(res.data){
                        if(res.data['_id']){
                            if(field){
                                new_obj['errMsg']='document.update:ok';
                                new_obj['stats']['update']=1;
                                this.doc(res.data['_id']);
                                this.t_data_.update({
                                    data:{
                                        [field]:this.command_.remove()
                                    }
                                }).catch((err)=>{
                                    this.error_(err);
                                });
                            }else{
                                new_obj['errMsg']='document.remove:ok';
                                new_obj['stats']['removed']=1;
                                this.doc(res.data['_id']);
                                this.t_data_.remove().catch((err)=>{
                                    this.error_(err);
                                });
                            }
                        }else if(res.data.constructor === Array){
                            if(field){
                                new_obj['errMsg']='document.update:ok';
                                new_obj['stats']['update']=0;
                                for(let i in res.data){
                                    new_obj['stats']['update']+=1;
                                    this.doc(res.data[i]['_id']);
                                    this.t_data_.update({
                                        data:{
                                            [field]:this.command_.remove()
                                        }
                                    }).catch((err)=>{
                                        this.error_(err);
                                    });
                                }
                            }else{
                                new_obj['errMsg']='document.remove:ok';
                                new_obj['stats']['removed']=0;
                                for(let i in res.data){
                                    new_obj['stats']['removed']+=1;
                                    this.doc(res.data[i]['_id']);
                                    this.t_data_.remove().catch((err)=>{
                                        this.error_(err);
                                    });
                                }
                            }
                        }
                    }
                    resolve(new_obj);
                });
            });
        }
    }
    /*先捕捉数据然后调用它，不支持id，统计符合条件的共有多少条*/
    count()
    {
        return this.t_data_.count().catch((err)=>{
            this.error_(err);
        });
    }
}

export default DB;
